#!/usr/bin/env python

import sys, os
import string, re
import random
use_message = '''
'''


def init_reads(read_prefix, num_reads = 20000000):
    files = [
        "sim.sam",
        "sim.simexpr",
        "sim.transfrags.gtf",
        "sim_1.fq",
        "sim_2.fq"
        ]

    for file in files:
        assert os.path.exists(file)

    head_cmd = "head -%d sim_1.fq > %s_1.fq" % (num_reads * 4, read_prefix)
    print >> sys.stderr, head_cmd
    os.system(head_cmd)
    head_cmd = "head -%d sim_2.fq > %s_2.fq" % (num_reads * 4, read_prefix)
    print >> sys.stderr, head_cmd
    os.system(head_cmd)

    print >> sys.stderr, "shuffle reads %s_1.fq and %s_2.fq" % (read_prefix, read_prefix)
    shuffle_pairs(read_prefix + "_1.fq", read_prefix + "_2.fq")
    shuffle_reads_cmd = " mv %s_1.fq.shuffle %s_1.fq" % (read_prefix, read_prefix)
    shuffle_reads_cmd += "; mv %s_2.fq.shuffle %s_2.fq" % (read_prefix, read_prefix)
    os.system(shuffle_reads_cmd)

    awk_cmd = "awk '{if($1 <= %d) print}' sim.sam > %s.sam" % (num_reads, read_prefix)
    print >> sys.stderr, awk_cmd
    os.system(awk_cmd)


def shuffle_reads(read_fname, random_list):
    reads = []
    read_file = open(read_fname)
    for line in read_file:
        if line[0] == "@":
            reads.append([])
        reads[-1].append(line[:-1])        
    read_file.close()

    read_fname_out = read_fname + ".shuffle"
    read_file_out = open(read_fname_out, "w")
    assert len(random_list) == len(reads)
    for i in random_list:
        read = reads[random_list[i]]
        print >> read_file_out, "\n".join(read)
    read_file_out.close()


def shuffle_pairs(read1_fname, read2_fname):
    read1_file = open(read1_fname)
    num_reads = 0
    for line in read1_file:
        if line[0] == "@":
            num_reads += 1
    read1_file.close()

    random_list = [i for i in range(num_reads)]
    random.shuffle(random_list)

    shuffle_reads(read1_fname, random_list)
    shuffle_reads(read2_fname, random_list)


if __name__ == "__main__":
    if len(sys.argv) == 3:
        random.seed(0)
        init_reads(sys.argv[1], int(sys.argv[2]))
